<template>
    <div class="content__leftAnalitika">
        <div class="settings animated fadeInUp">
            <p class="title-sett">{{ $t('settings.title') }}</p>
            <form action="" @submit.prevent="save">
                <div class="setting--input" v-for="(field, key) in fields">
                    <div class="text-left">{{ $t('settings.fields.general.' + key + '.label') }}:</div>
                    <div class="setting__input--right">
                        <div class="right__leftInput" v-if="field.type === 'text'">
                            <input type="text" v-model="settings[key]">
                        </div>
                        <div class="right__leftInput" v-else-if="field.type === 'integer'">
                            <input type="number" v-model.number="settings[key]">
                        </div>
                        <div class="right__leftInput" v-else-if="field.type === 'float'">
                            <input type="text" v-model.number="settings[key]">
                        </div>
                        <toggle v-model="settings[key]" :name="key" v-else-if="field.type === 'toggle'" class="right__left" input-class="box-c">
                            <template v-slot:off-label>
                                <p class="text-off">{{ $t('ui.off') }}</p>
                            </template>
                            <template v-slot:on-label>
                                <p class="text-off">{{ $t('ui.on') }}</p>
                            </template>
                        </toggle>
                        <div class="right__leftInput" v-else-if="field.type === 'date'">
                            <flat-pickr v-model="settings[key]" />
                        </div>
                        <tooltip :info="$t('settings.fields.general.' + key + '.help')"/>
                    </div>
                </div>
                <div class="setting--input" v-if="settings.tg_bot_enabled">
                    <div class="text-left">{{ $t('settings.telegram_bot_key') }}:</div>
                    <div class="setting__input--right">
                        <div class="right__leftInput">
                            <input type="text" readonly :value="telegram_key">
                        </div>
                    </div>
                </div>

                <button type="submit">{{ $t('settings.submit') }}</button>
            </form>
        </div>
        <div class="settings animated fadeInUp">
            <p class="title-sett">{{ $t('settings.social_auth') }}</p>
            <form action="" @submit.prevent="saveSocial">
                <div class="setting--input">
                    <div class="text-left">{{ $t('settings.fields.social_auth.enabled') }}:</div>
                    <div class="setting__input--right">
                        <toggle v-model="social_settings.enabled" name="enabled" class="right__left" input-class="box-c">
                            <template v-slot:off-label>
                                <p class="text-off">{{ $t('ui.off') }}</p>
                            </template>
                            <template v-slot:on-label>
                                <p class="text-off">{{ $t('ui.on') }}</p>
                            </template>
                        </toggle>
                    </div>
                </div>
                <div v-for="provider in social_providers" v-if="social_settings.enabled">
                    <div class="setting--input">
                        <div class="text-left">{{ getProviderName(provider) }} {{ $t('settings.fields.social_auth.provider_enabled') }}:</div>
                        <div class="setting__input--right">
                            <toggle v-model="social_settings[provider + '_enabled']" :name="provider + '_enabled'" class="right__left" input-class="box-c">
                                <template v-slot:off-label>
                                    <p class="text-off">{{ $t('ui.off') }}</p>
                                </template>
                                <template v-slot:on-label>
                                    <p class="text-off">{{ $t('ui.on') }}</p>
                                </template>
                            </toggle>
                        </div>
                    </div>
                    <div class="setting--input" v-if="social_settings[provider + '_enabled']">
                        <div class="text-left">{{ getProviderName(provider) }} client id:</div>
                        <div class="setting__input--right">
                            <div class="right__leftInput">
                                <input type="text" v-model="social_settings[provider + '_client_id']">
                            </div>
                        </div>
                    </div>
                    <div class="setting--input" v-if="social_settings[provider + '_enabled']">
                        <div class="text-left">{{ getProviderName(provider) }} client secret:</div>
                        <div class="setting__input--right">
                            <div class="right__leftInput">
                                <input type="text" v-model="social_settings[provider + '_client_secret']">
                            </div>
                        </div>
                    </div>
                    <div class="setting--input" v-if="social_settings[provider + '_enabled']">
                        <div class="text-left">{{ getProviderName(provider) }} redirect url</div>
                        <div class="setting__input--right">
                            <div class="right__leftInput">
                                <input type="text" readonly :value="getSocialProviderRedirectUrl(provider)">
                            </div>
                        </div>
                    </div>
                </div>
                <button type="submit">{{ $t('settings.submit') }}</button>
            </form>
        </div>
    </div>
</template>

<script>
import {mapGetters} from "vuex";

export default {
		name: "Settings",
        data(){
		    return {
		        fields: {},
		        settings: {},
                telegram_key: '',
                social_providers: ['facebook'],
                social_settings: {}
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ])
        },
        methods: {
            load(){
                this.axios.get(`settings/general`)
                    .then(resp => resp.data)
                    .then(settings => {
                        console.log(settings);
                        this.fields = settings.fields;
                        this.settings = settings.settings;
                        this.telegram_key = settings.telegram_key;
                    });
                setInterval(this.reloadToken, 300000);
            },
            loadSocial(){
                this.axios.get(`settings/social`)
                    .then(resp => resp.data)
                    .then(settings => {
                        console.log(settings);
                        this.social_providers = settings.providers;
                        this.social_settings = settings.settings;
                    });
            },
            reloadToken(){
                this.axios.get(`settings/general`)
                    .then(resp => resp.data)
                    .then(settings => {
                        console.log(settings);
                        this.telegram_key = settings.telegram_key;
                    });
            },
            save(){
                this.axios.post(`settings/general`, {
                    fields: this.settings
                })
                    .then(resp => resp.data)
                    .then(settings => {
                        console.log(settings);
                        this.settings = settings.settings;
                    });
            },
            saveSocial(){
                this.axios.post(`settings/social`, {
                    fields: this.social_settings
                })
                    .then(resp => resp.data)
                    .then(settings => {
                        console.log(settings);
                        this.social_settings = settings.settings;
                    });
            },
            getSocialProviderRedirectUrl(provider){
                return window.location.origin + '/login/' + provider + '/callback';
            },
            getProviderName(provider){
                return provider[0].toUpperCase() + provider.slice(1);
            }
        },
        mounted() {
            this.load();
            this.loadSocial();
        }
	}
</script>

<style scoped>

</style>
